From 8a1a967b3550270b641ac1f0b38bb4745afb084e Mon Sep 17 00:00:00 2001
From: Daniel Mierswa <impulze@impulze.org>
Date: Wed, 27 Jan 2010 20:39:23 +0100
Subject: [PATCH 09/11] Use new VLC_FEATURE macros in configure.ac.

I think it's bad style to override and tinker with enable_* strings on
your own. I choosed to implement the feature logic in m4 and provide
easy access macros to check for features.
This also fixes a small issue where in the output of configure it would
say "optim" if enable_optimizations was "yes" but that never happened,
because enable_optimizations was overwritten during the check.
I plan to move the whole configure.ac file to the VLC_FEATURE logic and
if bugs wrt the detection sneak in it should be a trivial fix.
AM_CONDITIONAL probed for enable_sqlite to be not set to "no", which
is the case if it was found by pkg-config (for example on darwin). The
new pkg-config check does no longer set enable_foo and so we need to
set a special variable. have_foo is a good choice, generally I think.
Also removed auto handling from PKG_ENABLE_MODULES_VLC since we always
use that.

Signed-off-by: Daniel Mierswa <impulze@impulze.org>
---
 configure.ac       |  304 +++++++++++++++++++++++----------------------------
 m4/vlc.m4          |   10 +-
 m4/vlc_features.m4 |  240 +++++++++++++++++++++++++++++++++++++++++
 m4/with_pkg.m4     |   32 ++----
 4 files changed, 392 insertions(+), 194 deletions(-)
 create mode 100644 m4/vlc_features.m4

diff --git a/configure.ac b/configure.ac
index 020d8f7..1a8ac63 100644
--- a/configure.ac
+++ b/configure.ac
@@ -212,35 +212,20 @@ case "${host_os}" in
         build_dir=`pwd`
         echo "  Assuming --prefix=${build_dir}/vlc_install_dir"
         ac_default_prefix="${build_dir}/vlc_install_dir"
-        enable_macosx="yes"
-        echo "  Assuming --enable-macosx"
-        enable_faad="yes"
-        echo "  Assuming --enable-faad"
-        enable_flac="yes"
-        echo "  Assuming --enable-flac"
-        enable_theora="yes"
-        echo "  Assuming --enable-theora"
-        enable_shout="yes"
-        echo "  Assuming --enable-shout"
-        enable_vcdx="yes"
-        echo "  Assuming --enable-vcdx"
-        enable_caca="yes"
-        echo "  Assuming --enable-caca"
-        enable_ncurses="yes"
-        echo "  Assuming --enable-ncurses"
-        enable_twolame="yes"
-        echo "  Assuming --enable-twolame"
-        enable_realrtsp="yes"
-        echo "  Assuming --enable-realrtsp"
-        enable_libass="yes"
-        echo "  Assuming --enable-libass"
-        enable_asademux="yes"
-        echo "  Assuming --enable-asademux"
-
-        enable_skins2="no"
-        echo "  Assuming --disable-skins2"
-        enable_xcb="no"
-        echo "  Assuming --disable-xcb"
+        VLC_FEATURE_FORCE_ENABLE([macosx])
+        VLC_FEATURE_FORCE_ENABLE([faad])
+        VLC_FEATURE_FORCE_ENABLE([flac])
+        VLC_FEATURE_FORCE_ENABLE([theora])
+        VLC_FEATURE_FORCE_ENABLE([shout])
+        VLC_FEATURE_FORCE_ENABLE([vcdx])
+        VLC_FEATURE_FORCE_ENABLE([caca])
+        VLC_FEATURE_FORCE_ENABLE([ncurses])
+        VLC_FEATURE_FORCE_ENABLE([twolame])
+        VLC_FEATURE_FORCE_ENABLE([realrtsp])
+        VLC_FEATURE_FORCE_ENABLE([libass])
+        VLC_FEATURE_FORCE_ENABLE([asademux])
+        VLC_FEATURE_FORCE_DISABLE([skins2])
+        VLC_FEATURE_FORCE_DISABLE([xcb])
     fi
     dnl
     dnl  Check for Mac OS X SDK settings
@@ -284,10 +269,8 @@ case "${host_os}" in
         CFLAGS="$save_cflags"
 
         if test "x$ac_ld_does_not_support_text_reloc" = "xyes"; then
-            enable_mmx="no"
-            echo "  Assuming --disable-mmx (due to a bug in ld)"
-            enable_sse="no"
-            echo "  Assuming --disable-sse (due to a bug in ld)"
+            VLC_FEATURE_FORCE_DISABLE([mmx], [due to a bug in ld])
+            VLC_FEATURE_FORCE_DISABLE([sse], [due to a bug in ld])
         fi
     fi
     ;;
@@ -1000,14 +983,14 @@ AC_CACHE_CHECK([if \$CC accepts -O4],
     [ac_cv_c_o4],
     [CFLAGS="${CFLAGS_save} -O4"
      AC_TRY_COMPILE([],,ac_cv_c_o4=yes, ac_cv_c_o4=no)])
-if test "${ac_cv_c_o4}" != "no" -a "x${enable_debug}" = "xno"; then
+if test "${ac_cv_c_o4}" != "no" && VLC_FEATURE_NOT_ENABLED([debug]); then
     CFLAGS_OPTIM_SPEED="${CFLAGS_OPTIM_SPEED} -O4"
 else
     AC_CACHE_CHECK([if \$CC accepts -O3],
         [ac_cv_c_o3],
         [CFLAGS="${CFLAGS_save} -O3"
          AC_TRY_COMPILE([],,ac_cv_c_o3=yes, ac_cv_c_o3=no)])
-    if test "${ac_cv_c_o3}" != "no" -a "x${enable_debug}" = "xno"; then
+    if test "${ac_cv_c_o3}" != "no" && VLC_FEATURE_NOT_ENABLED([debug]); then
         CFLAGS_OPTIM_SPEED="${CFLAGS_OPTIM_SPEED} -O3"
     else
         AC_CACHE_CHECK([if \$CC accepts -O2],
@@ -1126,12 +1109,14 @@ AC_CHECK_FUNCS(backtrace)
 dnl
 dnl  Enable profiling
 dnl
+VLC_FEATURE_DEFAULT_DISABLE([gprof])
+VLC_FEATURE_DEFAULT_DISABLE([cprof])
 AC_ARG_ENABLE(gprof,
 [  --enable-gprof          gprof profiling (default disabled)])
 AC_ARG_ENABLE(cprof,
 [  --enable-cprof          cprof profiling (default disabled)])
-test "${enable_gprof}" != "yes" && enable_gprof="no"
-test "${enable_cprof}" != "yes" && enable_cprof="no"
+AS_IF([VLC_FEATURE_ENABLED([cprof])], [vlc_config_cprof="yes"], [vlc_config_cprof="no"])
+AS_IF([VLC_FEATURE_ENABLED([gprof])], [vlc_config_gprof="yes"], [vlc_config_gprof="no"])
 
 dnl
 dnl  default modules
@@ -1168,20 +1153,16 @@ AC_ARG_WITH(,[Optimization options:])
 dnl  Check for fully working MMX intrinsics
 dnl  We need support for -mmmx, we need <mmintrin.h>, and we also need a
 dnl  working compiler (http://gcc.gnu.org/bugzilla/show_bug.cgi?id=23963)
+AS_CASE(
+  ["${host_cpu}"],
+  [i?86|x86_64], [VLC_FEATURE_DEFAULT_ENABLE([mmx])],
+  [VLC_FEATURE_DEFAULT_DISABLE([mmx])]
+)
 AC_ARG_ENABLE(mmx,
-[  --disable-mmx           disable MMX optimizations (default auto)],,[
-  case "${host_cpu}" in
-    i?86|x86_64)
-      enable_mmx="yes"
-      ;;
-    *)
-      enable_mmx="no"
-      ;;
-  esac
-])
+[  --disable-mmx           disable MMX optimizations (default auto)])
 have_mmx="no"
 have_mmxext="no"
-AS_IF([test "${enable_mmx}" != "no"], [
+AS_IF([VLC_FEATURE_NOT_DISABLED([mmx])], [
   ARCH="${ARCH} mmx"
 
   AC_CACHE_CHECK([if $CC groks MMX intrinsics],
@@ -1236,20 +1217,15 @@ AM_CONDITIONAL([HAVE_MMXEXT], [test "${have_mmxext}" = "yes"])
 dnl  Check for fully workin SSE2 intrinsics
 dnl  We need support for -mmmx, we need <emmintrin.h>, and we also need a
 dnl  working compiler (http://gcc.gnu.org/bugzilla/show_bug.cgi?id=23963)
+AS_CASE(
+  ["${host_cpu}"],
+  [i686|x86_64], [VLC_FEATURE_DEFAULT_ENABLE([sse])],
+  [VLC_FEATURE_DEFAULT_DISABLE([sse])]
+)
 AC_ARG_ENABLE(sse,
-[  --disable-sse           disable SSE (1, 2, 3 and 4) optimizations (default auto)],
-, [
-  case "${host_cpu}" in
-    i686|x86_64)
-      enable_sse=yes
-      ;;
-    *)
-      enable_sse=no
-      ;;
-  esac
-])
+[  --disable-sse           disable SSE (1, 2, 3 and 4) optimizations (default auto)])
 have_sse2="no"
-AS_IF([test "${enable_sse}" != "no"], [
+AS_IF([VLC_FEATURE_NOT_DISABLED([sse])], [
   ARCH="${ARCH} sse sse2"
 
   AC_CACHE_CHECK([if $CC groks SSE2 intrinsics],
@@ -1361,12 +1337,15 @@ AS_IF([test "${ac_cv_3dnow_inline}" != "no"], [
 ])
 AM_CONDITIONAL([HAVE_3DNOW], [test "$have_3dnow" = "yes"])
 
+AS_IF([test "x${host_cpu}" = "xarm"], [
+  VLC_FEATURE_DEFAULT_ENABLE([neon])
+], [
+  VLC_FEATURE_DEFAULT_DISABLE([neon])
+])
 
 AC_ARG_ENABLE(neon,
-[  --disable-neon          disable NEON optimizations (default auto)],, [
-  AS_IF([test "${host_cpu}" = "arm"], [enable_neon="yes"] ,[enable_neon="no"])
-])
-AS_IF([test "${enable_neon}" != "no"], [
+[  --disable-neon          disable NEON optimizations (default auto)])
+AS_IF([VLC_FEATURE_NOT_DISABLED([neon])], [
   AC_CACHE_CHECK([if $CC groks NEON inline assembly], [ac_cv_neon_inline], [
     CFLAGS="${CFLAGS_save} -mfpu=neon"
     AC_COMPILE_IFELSE([
@@ -1385,14 +1364,15 @@ AS_IF([test "${enable_neon}" != "no"], [
 AC_SUBST(ARM_NEON_CFLAGS)
 AM_CONDITIONAL(HAVE_ARM_NEON, [test "${ac_cv_neon_inline}" != "no"])
 
-
-AC_ARG_ENABLE(altivec,
-[  --disable-altivec       disable AltiVec optimizations (default auto)],, [
-  AS_IF([test "${host_cpu}" = "powerpc"],
-        [enable_altivec=yes], [enable_altivec=no])
+AS_IF([test "x${host_cpu}" = "xpowerpc"], [
+  VLC_FEATURE_DEFAULT_ENABLE([altivec])
+], [
+  VLC_FEATURE_DEFAULT_DISABLE([altivec])
 ])
+AC_ARG_ENABLE(altivec,
+[  --disable-altivec       disable AltiVec optimizations (default auto)])
 have_altivec="no"
-AS_IF([test "${enable_altivec}" = "yes"], [
+AS_IF([VLC_FEATURE_ENABLED([altivec])], [
   ARCH="${ARCH} altivec";
   AC_CACHE_CHECK([if $CC groks AltiVec inline assembly],
     [ac_cv_altivec_inline],
@@ -1543,23 +1523,26 @@ dnl  Enable/disable optimizations
 dnl
 AC_ARG_ENABLE(optimizations,
 [  --disable-optimizations disable compiler optimizations (default enabled)])
-if test "${enable_optimizations}" != "no"; then
-   if test "${enable_optimize_memory}" = "yes"; then
-      enable_optimizations="size"
-   else
-      enable_optimizations="speed"
-   fi
-fi
+AS_IF([VLC_FEATURE_NOT_DISABLED([optimizations])], [
+  AS_IF([VLC_FEATURE_ENABLED([optimize-memory])], [
+    vlc_config_optimizations="size"
+  ], [
+    vlc_config_optimizations="speed"
+  ])
+], [
+  vlc_config_optimizations="no"
+])
 
 dnl
 dnl  Debugging mode
 dnl
 AC_ARG_ENABLE(debug,
 [  --enable-debug          debug mode (default disabled)])
-test "${enable_debug}" != "yes" && enable_debug="no"
 AH_TEMPLATE(NDEBUG,
             [Define to 1 if debug code should NOT be compiled])
-AS_IF([test "x${enable_debug}" = "xno"], [
+vlc_config_debug="no"
+AS_IF([VLC_FEATURE_ENABLED([debug])], [
+  vlc_config_debug="yes"
   AC_DEFINE(NDEBUG)
 ], [
   AC_CHECK_HEADERS([valgrind/valgrind.h])
@@ -1579,9 +1562,8 @@ dnl
 dnl  Test coverage
 dnl
 AC_ARG_ENABLE(coverage,
-	[  --enable-coverage       build for test coverage (default disabled)],,
-	[enable_coverage="no"])
-AS_IF([test "${enable_coverage}" != "no"], [
+	[  --enable-coverage       build for test coverage (default disabled)])
+AS_IF([VLC_FEATURE_ENABLED([coverage])], [
 	CFLAGS="-fprofile-arcs -ftest-coverage ${CFLAGS}"
 	CXXFLAGS="-fprofile-arcs -ftest-coverage ${CXXFLAGS}"
 	LDFLAGS="-lgcov ${LDFLAGS}"
@@ -1596,7 +1578,7 @@ dnl  Enable release-specific flags
 dnl
 AC_ARG_ENABLE(release,
 [  --enable-release        activate extra optimizations (default disabled)])
-test "${enable_release}" != "yes" && enable_release="no"
+AS_IF([VLC_FEATURE_ENABLED([release])], [vlc_config_release="yes"], [vlc_config_release="no"])
 
 dnl
 dnl Stream output
@@ -1682,25 +1664,24 @@ AS_IF([test "${enable_libproxy}" != "no"], [
 dnl
 dnl VideoLAN manager
 dnl
+VLC_FEATURE_DEFAULT([vlm], ["${enable_sout}"])
 AC_ARG_ENABLE(vlm,
-  [  --enable-vlm            VideoLAN manager (default enabled)],,
-  [enable_vlm="${enable_sout}"])
-AS_IF([test "${enable_vlm}" != "no"], [
+  [  --enable-vlm            VideoLAN manager (default enabled)])
+AS_IF([VLC_FEATURE_NOT_DISABLED([vlm])], [
   AS_IF([test "${enable_sout}" = "no"], [
     AC_MSG_ERROR([VLM requires the stream output. Do not use --disable-sout.])
   ])
   AC_DEFINE(ENABLE_VLM, 1, [Define if you want the VideoLAN manager support])
   VLC_ADD_PLUGIN([oldtelnet])
 ])
-AM_CONDITIONAL([ENABLE_VLM], [test "${enable_vlm}" != "no"])
+AM_CONDITIONAL([ENABLE_VLM], [VLC_FEATURE_NOT_DISABLED([vlm])])
 
 dnl
 dnl Growl notification plugin
 dnl
 AC_ARG_ENABLE(growl,
-  [  --enable-growl          growl notification plugin (default disabled)],,
-  [enable_growl=no])
-AS_IF([test "${enable_growl}" != "no"], [
+  [  --enable-growl          growl notification plugin (default disabled)])
+AS_IF([VLC_FEATURE_ENABLED([growl])], [
     VLC_ADD_PLUGIN([growl_udp])
     AC_CHECK_HEADERS(Growl/GrowlDefines.h, [
       VLC_ADD_PLUGIN([growl])
@@ -2301,9 +2282,7 @@ dnl  VCDX modules
 dnl
 AC_ARG_ENABLE(vcdx,
   [  --enable-vcdx           VCD with navigation via libvcdinfo (default disabled)])
-
-if test "${enable_vcdx}" = "yes"
-then
+AS_IF([VLC_FEATURE_ENABLED([vcdx])], [
 	PKG_CHECK_MODULES(LIBCDIO, [libcdio >= 0.78.2 libiso9660 >= 0.72],
 	  [VLC_ADD_LIBS([vcdx],[$LIBCDIO_LIBS])
 		 VLC_ADD_CFLAGS([vcdx],[$LIBCDIO_CFLAGS])],
@@ -2313,7 +2292,7 @@ then
 		 VLC_ADD_CFLAGS([vcdx],[$LIBVCDINFO_CFLAGS])],
 	  [AC_MSG_ERROR([vcdx plugin requires libvcdinfo library >= 0.7.22])])
         VLC_ADD_PLUGIN([vcdx])
-fi
+])
 
 dnl
 dnl  Built-in CD-DA and VCD module
@@ -2896,8 +2875,7 @@ dnl  faad decoder plugin
 dnl
 AC_ARG_ENABLE(faad,
 [  --enable-faad           faad codec (default disabled)])
-if test "${enable_faad}" = "yes"
-then
+AS_IF([VLC_FEATURE_ENABLED([faad])], [
   AC_ARG_WITH(faad-tree,
   [  --with-faad-tree=PATH   faad tree for static linking])
   if test -n "${with_faad_tree}"
@@ -2937,7 +2915,7 @@ then
     LDFLAGS="${LDFLAGS_save}"
     CPPFLAGS="${CPPFLAGS_save}"
   fi
-fi
+])
 
 dnl
 dnl twolame encoder plugin
@@ -2974,9 +2952,9 @@ dnl  Real RTSP plugin
 dnl
 AC_ARG_ENABLE(realrtsp,
   [  --enable-realrtsp       Real RTSP module (default disabled)])
-if test "${enable_realrtsp}" = "yes"; then
+AS_IF([VLC_FEATURE_ENABLED([realrtsp])], [
   VLC_ADD_PLUGIN([access_realrtsp])
-fi
+])
 
 AC_ARG_ENABLE(libsysfs,
   [  --enable-libsysfs       Get user key from firewire connected iPod via libsysfs (default enabled)])
@@ -3259,7 +3237,7 @@ dnl libass subtitle rendering module
 dnl
 AC_ARG_ENABLE(libass,
   [  --enable-libass         Subtitle support using libass (default enabled)])
-AS_IF( [test "${enable_libass}" != "no"], [
+AS_IF([VLC_FEATURE_NOT_DISABLED([libass])], [
   PKG_CHECK_MODULES(LIBASS, libass >= 0.9.6,
       [
         VLC_ADD_LIBS([libass],[$LIBASS_LIBS])
@@ -3280,7 +3258,7 @@ dnl asa demuxer
 dnl
 AC_ARG_ENABLE(asademux,
   [  --enable-asademux       asa subtitle demuxing (default disabled)])
-AS_IF( [test "${enable_asademux}" = "yes"], [
+AS_IF([VLC_FEATURE_ENABLED([asademux])], [
   PKG_CHECK_MODULES(PCRE,
       libpcre >= 6.5,
       [
@@ -3358,28 +3336,31 @@ AC_PATH_XTRA()
 dnl
 dnl  X C Bindings modules
 dnl
-AC_ARG_ENABLE(xcb,
-  [  --enable-xcb            X11 support with XCB (default enabled)],, [
-  AS_IF([test "${SYS}" != "mingw32" -a "${SYS}" != "mingwce" -a "${SYS}" != "darwin"], [
-    enable_xcb="yes"
-  ], [
-    enable_xcb="no"
-  ])
+AS_CASE(
+  ["${SYS}"],
+  [mingw32|mingwce|darwin], [VLC_FEATURE_DEFAULT_DISABLE([xcb])],
+  [VLC_FEATURE_DEFAULT_ENABLE([xcb])
 ])
-AC_ARG_ENABLE(xvideo,
-  [  --enable-xvideo         XVideo support (default enabled)],, [
-    enable_xvideo="$enable_xcb"
+
+AS_IF([VLC_FEATURE_REMOVED([xcb])], [
+  VLC_FEATURE_DEFAULT_DISABLE([xvideo])
+  VLC_FEATURE_DEFAULT_DISABLE([glx])
 ])
 
+AC_ARG_ENABLE(xcb,
+  [  --enable-xcb            X11 support with XCB (default enabled)])
+AC_ARG_ENABLE(xvideo,
+  [  --enable-xvideo         XVideo support (default enabled)])
+
 need_xid_provider="no"
-AS_IF([test "${enable_xcb}" != "no"], [
+AS_IF([VLC_FEATURE_NOT_DISABLED([xcb])], [
   dnl libxcb
   PKG_CHECK_MODULES(XCB, [xcb])
   PKG_CHECK_MODULES(XCB_SHM, [xcb-shm])
   VLC_ADD_PLUGIN([screensaver xcb_x11 xcb_screen xcb_apps])
   VLC_SET_CFLAGS_WERROR([xcb_screen], [-Wno-error=uninitialized]) # some gcc report a warning which doesn't reveal an error
 
-  AS_IF([test "${enable_xvideo}" != "no"], [
+  AS_IF([VLC_FEATURE_NOT_DISABLED([xvideo])], [
     PKG_CHECK_MODULES(XCB_XV, [xcb-xv >= 1.1.90.1], [
       VLC_ADD_PLUGIN([xcb_xv])
     ], [
@@ -3419,10 +3400,8 @@ AS_IF([test "${enable_xcb}" != "no"], [
 ])
 
 AC_ARG_ENABLE(glx,
-  [  --enable-glx            X11 OpenGL (GLX) support (default enabled)],, [
-  enable_glx="$enable_xcb"
-])
-AS_IF([test "${enable_glx}" != "no"], [
+  [  --enable-glx            X11 OpenGL (GLX) support (default enabled)])
+AS_IF([VLC_FEATURE_NOT_DISABLED([glx])], [
   PKG_CHECK_MODULES(XLIB_XCB, [x11-xcb])
   PKG_CHECK_MODULES(GL, [gl],, [
     AC_CHECK_HEADER([GL/gl.h], [
@@ -3975,19 +3954,21 @@ dnl
 AC_ARG_ENABLE(skins2,
   [AS_HELP_STRING([--enable-skins2],[Skins2 interface module (default
    enabled except on MacOSX, BeOS and WinCE)])])
-if test "${enable_skins2}" = "yes" ||
-  (test "${SYS}" != "darwin" && test "${SYS}" != "beos" &&
-   test "${SYS}" != "mingwce" && test "${enable_skins2}" != "no"); then
-
+AS_CASE(
+  ["${SYS}"],
+  [darwin|beos|mingwce], [],
+  [VLC_FEATURE_DEFAULT_ENABLE([skins2])]
+)
+AS_IF([VLC_FEATURE_ENABLED([skins2])], [
   dnl test for the required libraries
   skins2_missing_lib="no"
 
   dnl freetype
   if test "${have_freetype}" != "yes"; then
     skins2_missing_lib="yes"
-    if test "${enable_skins2}" = "yes"; then
+    AS_IF([VLC_FEATURE_REQUESTED([skins2])], [
       AC_MSG_ERROR([Could not find freetype (required for skins2)])
-    fi
+    ])
   fi
 
   if test "${skins2_missing_lib}" = "no" && (test "${SYS}" = "mingw32"); then
@@ -4012,17 +3993,15 @@ if test "${enable_skins2}" = "yes" ||
     VLC_ADD_LIBS([skins2],[${X_LIBS} ${X_PRE_LIBS} -lXext -lX11])
     need_xid_provider="no"
   fi fi fi
-fi
-AM_CONDITIONAL(BUILD_SKINS, [test "${enable_skins2}" = "yes" ||
-	 (test "${SYS}" != "darwin" && test "${SYS}" != "beos" &&
-	  test "${SYS}" != "mingwce" && test "${enable_skins2}" != "no")])
+])
+AM_CONDITIONAL(BUILD_SKINS, [test "${skins2_missing_lib}" = "no"])
 
 dnl
 dnl Hildon UI
 dnl
 AC_ARG_ENABLE(hildon,
   [  --enable-hildon         Hildon touchscreen UI (default disabled)])
-AS_IF([test "${enable_hildon}" = "yes"], [
+AS_IF([VLC_FEATURE_ENABLED([hildon])], [
   PKG_CHECK_MODULES(HILDON, [hildon-1 hildon-fm-2], [
     VLC_ADD_CFLAGS([hildon],[${HILDON_CFLAGS}])
     VLC_ADD_LIBS([hildon],[${HILDON_LIBS}])
@@ -4030,22 +4009,18 @@ AS_IF([test "${enable_hildon}" = "yes"], [
     ALIASES="${ALIASES} mvlc"
     need_xid_provider="no"
   ], [
-    AS_IF([test "${enable_hildon}" = "yes"],[
-      AC_MSG_ERROR([Hildon libraries not found])
-    ])
-    enable_hildon="no"
+    AC_MSG_ERROR([Hildon libraries not found])
   ])
 ])
-AM_CONDITIONAL(BUILD_HILDON, [test "${enable_hildon}" = "yes"])
+AM_CONDITIONAL(BUILD_HILDON, [VLC_FEATURE_ENABLED([hildon])])
 
 dnl
 dnl QT 4
 dnl
+AS_IF([test "x${SYS}" = "xdarwin"], [VLC_FEATURE_DEFAULT_DISABLE([qt4])])
 AC_ARG_ENABLE(qt4,
-  [  --enable-qt4            Qt 4 support (default enabled) ],, [
-  AS_IF([test "${SYS}" = "darwin"], [enable_qt4=no])
-])
-AS_IF([test "${enable_qt4}" != "no"], [
+  [  --enable-qt4            Qt 4 support (default enabled) ])
+AS_IF([VLC_FEATURE_NOT_DISABLED([qt4])], [
   PKG_CHECK_MODULES(QT4, [QtCore QtGui >= 4.4.0], [
     VLC_ADD_PLUGIN([qt4])
     ALIASES="${ALIASES} qvlc"
@@ -4061,21 +4036,21 @@ AS_IF([test "${enable_qt4}" != "no"], [
     AC_PATH_PROGS(MOC, [moc-qt4 moc], moc,`eval $PKG_CONFIG --variable=exec_prefix QtCore`/bin)
     AC_PATH_PROG(RCC, rcc, rcc,`eval $PKG_CONFIG --variable=exec_prefix QtCore`/bin)
     AC_PATH_PROGS(UIC, [uic-qt4 uic], uic,`eval $PKG_CONFIG --variable=exec_prefix QtCore`/bin)
+    have_qt4="yes"
   ], [
-    AS_IF([test "${enable_qt4}" = "yes"],[
+    AS_IF([VLC_FEATURE_REQUESTED([qt4])], [
       AC_MSG_ERROR([Qt 4 library not found])
     ],[
       AC_MSG_WARN([Qt 4 library not found])
     ])
-    enable_qt4="no"
   ])
 ])
-AM_CONDITIONAL(ENABLE_QT4, [test "x$enable_qt4" != "xno"])
+AM_CONDITIONAL(ENABLE_QT4, [test "x$have_qt4" = "xyes"])
 
 dnl
 dnl Simple test for skins2 dependency
 dnl
-AS_IF([test "${enable_skins2}" != "no" && test "x$enable_qt4" = "xno"], [
+AS_IF([VLC_FEATURE_NOT_DISABLED([skins2]) && test "x$have_qt4" != "xyes"], [
   AC_MSG_ERROR([The skins2 module depends on a the Qt4 development package. Without it you won't be able to open any dialog box from the interface, which makes the skins2 interface rather useless. Install the Qt4 development package or alternatively you can also configure with: --disable-qt4 --disable-skins2.])
 ])
 
@@ -4084,8 +4059,7 @@ dnl  MacOS X video output/gui modules
 dnl
 AC_ARG_ENABLE(macosx,
   [  --enable-macosx         Mac OS X gui support (default enabled on Mac OS X)])
-if test "x${enable_macosx}" = "xyes"
-then
+AS_IF([VLC_FEATURE_ENABLED([macosx])], [
   VLC_ADD_LDFLAGS([macosx minimal_macosx],[-Wl,-framework,Cocoa])
   VLC_ADD_LDFLAGS([macosx minimal_macosx],[-Wl,-framework,OpenGL])
   VLC_ADD_LDFLAGS([macosx minimal_macosx],            [-Wl,-framework,Carbon])
@@ -4100,7 +4074,7 @@ then
   VLC_ADD_OBJCFLAGS([macosx minimal_macosx], [-fobjc-exceptions] )
 
   VLC_ADD_PLUGIN([macosx minimal_macosx])
-fi
+])
 
 dnl
 dnl  MacOS X related modules
@@ -4157,8 +4131,8 @@ dnl
 dnl  ncurses module
 dnl
 AC_ARG_ENABLE(ncurses,
-  [  --disable-ncurses       ncurses interface support (default disabled)],
-  [if test "${enable_ncurses}" != "no"; then
+  [  --disable-ncurses       ncurses interface support (default disabled)])
+AS_IF([VLC_FEATURE_ENABLED([ncurses])], [
     AC_CHECK_HEADER(ncurses.h,
       [AC_CHECK_LIB(ncursesw, mvprintw,
         [VLC_ADD_PLUGIN([ncurses])
@@ -4168,10 +4142,8 @@ AC_ARG_ENABLE(ncurses,
         AC_CHECK_LIB(ncursesw, tgetent, [],
           AC_CHECK_LIB(tinfow, tgetent, [VLC_ADD_LIBS([ncurses],[-ltinfow])],
             [AC_CHECK_LIB(tinfo, tgetent, [VLC_ADD_LIBS([ncurses],[-ltinfo])],
-              [AS_IF([test "x${enable_ncurses}" != "x"],
-                [AC_MSG_ERROR([tgetent not found in ncursesw tinfow tinfo]
-               )])])
-            ]
+                [AC_MSG_ERROR([tgetent not found in ncursesw tinfow tinfo])]
+            ])
           )
         )
         ],
@@ -4181,17 +4153,14 @@ AC_ARG_ENABLE(ncurses,
           VLC_ADD_LIBS([ncurses],[-lncurses])
           AC_CHECK_LIB(ncurses, tgetent, [],
             [AC_CHECK_LIB(tinfo, tgetent, [VLC_ADD_LIBS([ncurses],[-ltinfo])],
-              [AS_IF([test "x${enable_ncurses}" != "x"],
-                [AC_MSG_ERROR([tgetent not found in ncurses tinfo])])]
+                [AC_MSG_ERROR([tgetent not found in ncurses tinfo])]
             )]
           )],
-          [AS_IF([test "x${enable_ncurses}" != "x"], [
-            AC_MSG_ERROR([libncurses not found])])]
+          [AC_MSG_ERROR([libncurses not found])]
         )]
       )]
     )
-  fi]
-)
+])
 
 dnl
 dnl  XOSD plugin
@@ -4252,8 +4221,8 @@ dnl  AtmoLight (homemade Philips Ambilight clone)
 dnl
 AC_ARG_ENABLE(atmo,
 AS_HELP_STRING([--disable-atmo],[AtmoLight (homemade Philips Ambilight clone)
-                (default enabled)]),, [enable_atmo="yes"])
-AS_IF([test "${enable_atmo}" != no], [
+                (default enabled)]))
+AS_IF([VLC_FEATURE_NOT_DISABLED([atmo])], [
   AS_IF([test "${SYS}" = "mingw32" -o "${SYS}" = "linux"], [
     AC_LANG_PUSH(C++)
     VLC_ADD_PLUGIN([atmo])
@@ -4332,9 +4301,9 @@ AS_IF([test "${have_libgcrypt}" != "yes"], [
   AS_IF([test "${enable_gnutls}" = "yes"], [
     AC_MSG_ERROR([--enable-gnutls and --disable-libgcrypt are mutually exclusive.])
   ])
-  enable_gnutls="no"
+  VLC_FEATURE_DEFAULT_DISABLE([gnutls])
 ])
-AS_IF([test "${enable_gnutls}" != "no"], [
+AS_IF([VLC_FEATURE_NOT_DISABLED([gnutls])], [
   PKG_CHECK_MODULES(GNUTLS, [gnutls >= 1.7.4], [
     VLC_ADD_PLUGIN([gnutls])
     VLC_ADD_CFLAGS([gnutls], [$GNUTLS_CFLAGS])
@@ -4349,7 +4318,7 @@ AS_IF([test "${enable_gnutls}" != "no"], [
     ])
     VLC_ADD_LIBS([gnutls], [$GNUTLS_LIBS])
   ], [
-    AS_IF([test "${enable_gnutls}" = "yes"], [
+    AS_IF([VLC_FEATURE_REQUESTED([gnutls])], [
       AC_MSG_ERROR([gnutls not present or too old (version 1.7.4 required)])
     ])
   ])
@@ -4438,6 +4407,7 @@ else
           VLC_ADD_CFLAGS([sqlite],[-I${with_sqlite}/include])
           VLC_ADD_LIBS([sqlite], [-L${with_sqlite}/lib -lsqlite3])
           AC_MSG_RESULT(yes)
+          have_sqlite="yes"
         else
           VLC_ADD_LIBS([sqlite], [-lsqlite3])
         fi
@@ -4445,7 +4415,7 @@ else
         AC_MSG_ERROR([sqlite3 is required for sqlite module]) )
   fi
 fi
-AM_CONDITIONAL([HAVE_SQLITE], [test "${enable_sqlite}" != "no"])
+AM_CONDITIONAL([HAVE_SQLITE], [test "x${have_sqlite}" = "xyes"])
 
 
 dnl
@@ -4964,11 +4934,11 @@ version               : ${VERSION}
 system                : ${SYS}
 architecture          : ${ARCH}
 build flavour         : "
-test "${enable_debug}" = "yes" && printf "debug "
-test "${enable_cprof}" = "yes" && printf "cprof "
-test "${enable_gprof}" = "yes" && printf "gprof "
-test "${enable_optimizations}" = "yes" && printf "optim "
-test "${enable_release}" = "yes" && printf "release " || printf "devel "
+AS_IF([VLC_FEATURE_ENABLED([debug])], [printf "debug "])
+AS_IF([VLC_FEATURE_ENABLED([cprof])], [printf "cprof "])
+AS_IF([VLC_FEATURE_ENABLED([gprof])], [printf "gprof "])
+AS_IF([VLC_FEATURE_NOT_DISABLED([optimizations])], [printf "optim "])
+AS_IF([VLC_FEATURE_ENABLED([release])], [printf "release "], [printf "devel "])
 echo ""
 if test "${enable_vlc}" != "no"; then
 echo "vlc aliases           :${ALIASES}"
diff --git a/m4/vlc.m4 b/m4/vlc.m4
index 38fd988..f434d68 100644
--- a/m4/vlc.m4
+++ b/m4/vlc.m4
@@ -99,11 +99,11 @@ AC_DEFUN([VLC_OUTPUT_VLC_CONFIG_IN], [
 
   rm -f vlc-config.in
   sed -ne '/#@1@#/q;p' < "${srcdir}/vlc-config.in.in" \
-    | sed -e "s/@gprof@/${enable_gprof}/" \
-          -e "s/@cprof@/${enable_cprof}/" \
-          -e "s/@optim@/${enable_optimizations}/" \
-          -e "s/@debug@/${enable_debug}/" \
-          -e "s/@release@/${enable_release}/" \
+    | sed -e "s/@gprof@/${vlc_config_gprof}/" \
+          -e "s/@cprof@/${vlc_config_cprof}/" \
+          -e "s/@optim@/${vlc_config_optimizations}/" \
+          -e "s/@debug@/${vlc_config_debug}/" \
+          -e "s/@release@/${vlc_config_release}/" \
           -e "s/@PLUGINS@/${PLUGINS}/" \
           -e "s/@BUILTINS@/${BUILTINS}/" \
           -e "s/@CFLAGS_TUNING@/${CFLAGS_TUNING}/" \
diff --git a/m4/with_pkg.m4 b/m4/with_pkg.m4
index 7925317..a70dc1d 100644
--- a/m4/with_pkg.m4
+++ b/m4/with_pkg.m4
@@ -35,31 +35,17 @@ AC_DEFUN([PKG_WITH_MODULES],
 [
 AC_REQUIRE([PKG_PROG_PKG_CONFIG])
 m4_pushdef([with_arg], m4_tolower([$1]))
-
 m4_pushdef([description],
            [m4_default([$5], [build with ]with_arg[ support enabled])])
 
-m4_pushdef([def_arg], [m4_default([$6], [auto])])
-m4_pushdef([def_action_if_found], [AS_TR_SH([enable_]with_arg)=yes])
-m4_pushdef([def_action_if_not_found], [AS_TR_SH([enable_]with_arg)=no])
-
-m4_case(def_arg,
-            [yes],[m4_pushdef([with_without], [--disable-]with_arg)],
-            [m4_pushdef([with_without],[--enable-]with_arg)])
-
 AC_ARG_ENABLE(with_arg,
-     AS_HELP_STRING(with_without, description[ @<:@default=]def_arg[@:>@]),,
-    [AS_TR_SH([enable_]with_arg)=def_arg])
+     AS_HELP_STRING([--enable-]with_arg, description[ @<:@default=]auto[@:>@]))
 
-AS_CASE([$AS_TR_SH([enable_]with_arg)],
-            [yes],[PKG_CHECK_MODULES([$1],[$2],$3,$4)],
-            [auto],[PKG_CHECK_MODULES([$1],[$2],
-                                        [m4_n([def_action_if_found]) $3],
-                                        [m4_n([def_action_if_not_found]) $4])])
+AS_IF([VLC_FEATURE_NOT_DISABLED(with_arg)], [
+     PKG_CHECK_MODULES([$1],[$2],[$3],[$4])])
 
 m4_popdef([with_arg])
 m4_popdef([description])
-m4_popdef([def_arg])
 
 ]) dnl PKG_WITH_MODULES
 
@@ -89,11 +75,13 @@ PKG_WITH_MODULES([$1],[$3],
     VLC_ADD_PLUGIN(module_name)
     m4_ifval( m4_normalize([$8]), VLC_ADD_CPPFLAGS(module_name, [$8]))
     VLC_ADD_CFLAGS(module_name,[$$1_CFLAGS] [$6])
-    VLC_ADD_LIBS(module_name,[$$1_LIBS] [$7]),
-    AS_IF([test x"$AS_TR_SH([enable_]enable_arg)" = "xyes"],
-        [AC_MSG_ERROR(Library [$3] needed for [m4_tolower([$1])] was not found)],
-        [AC_MSG_WARN(Library [$3] needed for [m4_tolower([$1])] was not found)]
-         ),
+    VLC_ADD_LIBS(module_name,[$$1_LIBS] [$7])
+    AS_TR_SH([have_]enable_arg)="yes",
+    AS_IF([VLC_FEATURE_REQUESTED(enable_arg)],
+      [AC_MSG_ERROR(Library [$3] needed for [m4_tolower([$1])] was not found)])
+    AS_IF([VLC_FEATURE_DEFAULT_ENABLED(enable_arg)],
+      [AC_MSG_WARN(Library [$3] needed for [m4_tolower([$1])] was not found)])
+    AS_TR_SH([have_]enable_arg)="no",
     [$4],[$5])
 
 m4_popdef([module_name])
-- 
1.6.6.1


